/************************************************************************
Simple Form Mail Project        http://www.qDecoder.org/projects/qmailer/
qDecoder - C/C++ CGI Library                      http://www.qDecoder.org

Copyright (C) 2001 The qDecoder Project.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Copyright Disclaimer:
  Dae-heung Park., hereby disclaims all copyright interest.
  Author, Dae-heung Park, 30 April 2001
************************************************************************/

typedef struct
{
	char*	pszVersion;
	char*	pszQMailerURL;
	
	char*	pszSkinDirectory;
	char*	pszDefaultSkin;
	char*	pszMailHeader;
	char*	pszMailFooter;

	char*	pszBodyToHTML;
	char*	pszMailHeaderOption;
	char*	pszMailFooterOption;
	char*	pszPreview;
	char*	pszSubjectPrefix;
	char*	pszSubject;

	char*	pszToNameMode;
	char*	pszFromNameMode;
	char*	pszCCMode;
	char*	pszBCCMode;
	char*	pszHTMLFileMode;
	char*	pszAttachFileMode;
	
	char*	pszToNameOpen;
	char*	pszToNameClose;
	char*	pszFromNameOpen;
	char*	pszFromNameClose;
	char*	pszCCOpen;
	char*	pszCCClose;
	char*	pszBCCOpen;
	char*	pszBCCClose;
	char*	pszHTMLFileOpen;
	char*	pszHTMLFileClose;
	char*	pszAttachFileOpen;
	char*	pszAttachFileClose;
	char*	pszPreviewOpen;
	char*	pszPreviewClose;

	char*	pszPreviewMode;
	char*	pszSubmitMode;
	char*	pszPreviewSkinImage;
	char*	pszSubmitSkinImage;
} QMAILER_CONF;

char*		qHtmlize(char *buf);
char*		qMailize(char *buf);
int		qSedString(Q_Entry* first, char* filename, char* pString);
Q_Entry*	qSedArgAppend(Q_Entry *first, char *name, char *format, ...);
