#include	<stdio.h>
#include	<unistd.h>
#include <sys/time.h>
#include	<sys/param.h>
#include	<sys/socket.h>
#include	<netinet/in.h>
#include	<netdb.h>
#include	<signal.h>
#include	<stdlib.h>
#include	"qDecoder.h"
#include	"qSendmail.h"

SMTPInfo		SMTPCodes[] = {
{  0, "211 ", "ý  ޼" },
{  1, "214 ", " ޼" },
{  2, "220 ", " غ" },
{  3, "221 ", " " },
{  4, "250 ", "ɾ  Ϸ" },
{  5, "251 ", "ڰ  ƴ  " },
{  6, "354 ", " ޼ Է" },
{  7, "421 ", " Ȱ Ұ" },
{  8, "450 ", "ɾ ,  Ȱ   " },
{  9, "451 ", "  ɾ ߴܵ" },
{ 10, "452 ", "ý  ؼ ɾ Ϸ " },
{ 11, "500 ", "ν   ɾ()" },
{ 12, "501 ", "ɾ ڿ " },
{ 13, "502 ", "  ɾ" },
{ 14, "503 ", "߸ ɾ " },
{ 15, "504 ", "  ɾ Ķ" },
{ 16, "550 ", " Ȱ   ɾ " },
{ 17, "551 ", "ڰ  ƴϾ õ" },
{ 18, "552 ", "Ŭ̾Ʈ Ҵ   ʰؼ ɾ ߴܵ" },
{ 19, "553 ", " ̸ ȿ ʾƼ ɾ ߴܵ" },
{ 20, "554 ", "Ʈ " },
{ 21, ""   , ""}
};

// Prototype
void	sendSMTP( SMTP_RESULT* pResult, SMTP_CHANNEL smtp_channel, HEADER header, char* pszHeader, DATUM body );
int	checkQueue(int fd);
int	readLine(int fd, char* ptr, int maxlen);
unsigned char *base64_encode(const unsigned char *str, int length, int *ret_length);

void qSendmail( SMTP_RESULT* pResult, SMTP_CHANNEL smtp_channel, HEADER header, char* pszBody, DATUM attach )
{
//	Q_CGIenv	env;
	DATUM	body;
	char*	pEncode = NULL;
	char*	pReplace = NULL;
	char*	pBody = NULL;
	char*	pszHeader = NULL;
	char	attach_type[64] = "application/octet-stream";
	char	uniqid[128];
	char	boundary[256];
	int	sec, usec;
	struct timeval	tv;
	int	iIndex, iCount;
	int	iLength;

//	qCGIenv(&env);
	
	iLength = 1024+2*(strlen(header.pszTo)+strlen(header.pszCc)+strlen(header.pszBcc)+strlen(header.pszXMailer));
	pszHeader = (char*) malloc(iLength);
	if(!pszHeader)	qError("Header (%d)Memory allocation error.", iLength);

	iLength = 2*(1024*1024)+(((attach.dsize + 3 - attach.dsize % 3) * 4 / 3 + 1) * sizeof(char));
	pBody = (char*) malloc(iLength);
	if(!pBody)		qError("Body (%d)Memory allocation error.", iLength);

	sprintf(pszHeader, "Reply-To: %s <%s>\r\n", header.pszFromName, header.pszFrom);
	sprintf(pszHeader, "%sErrors-To: %s <%s>\r\n", pszHeader, header.pszFromName, header.pszFrom);
	sprintf(pszHeader, "%sReturn-Path: %s <%s>\r\n", pszHeader, header.pszFromName, header.pszFrom);
	sprintf(pszHeader, "%sFrom: %s <%s>\r\n", pszHeader, header.pszFromName, header.pszFrom);
	sprintf(pszHeader, "%sTo: %s <%s>\r\n", pszHeader, header.pszToName, header.pszTo);
	sprintf(pszHeader, "%sCc: %s\r\n", pszHeader, header.pszCc);
//	sprintf(pszHeader, "%sBcc: %s\r\n", pszHeader, header.pszBcc);
	sprintf(pszHeader, "%sX-Mailer: %s\r\n", pszHeader, header.pszXMailer);
	
	if (attach.dptr && attach.dsize)
	{
		pEncode = (char*) base64_encode((unsigned char const*)attach.dptr, attach.dsize, &iLength);
		pReplace = (char*) malloc(iLength+(2*(iLength/80))+1024);
		if(!pReplace)	qError("Replace (%d)Memory allocation error.", iLength);

		iIndex = 0;
		iCount = 0;
		pReplace[ iCount++ ] = pEncode[ iIndex++ ];
		while ( iIndex < iLength )
		{
			if ( !(iIndex%80) )
			{
				pReplace[ iCount++ ] = 0x0D;
				pReplace[ iCount++ ] = 0x0A;
			}
			pReplace[ iCount++ ] = pEncode[ iIndex++ ];
		}
		pReplace[ iCount ] ='\x0';
		
		if (attach_type[ 0 ] == '\x0') 
		{
			strcpy(attach_type, "application/octet-stream");
		}
		
		free( pEncode );
		
		gettimeofday((struct timeval *) &tv, (struct timezone *) NULL);
		sec = (int) tv.tv_sec;
		usec = (int) (tv.tv_usec % 1000000);
	
		// The max value usec can have is 0xF423F, so we use only five hex digits for usecs.
		sprintf(uniqid, "part%08x%05x", sec, usec);
		sprintf(boundary, "--------%s", uniqid);
		
		sprintf(pszHeader, "%sMIME-Version: 1.0\r\n", pszHeader);
		sprintf(pszHeader, "%sContent-Type: multipart/mixed; boundary=\"%s\"\r\n", pszHeader, boundary);
		
		iIndex = sprintf(&pBody[ 0 ], "This is a multi-part message in MIME format.\r\n\r\n");
		iIndex += sprintf(&pBody[ iIndex ], "--%s\r\n", boundary);
		
		iIndex += sprintf(&pBody[ iIndex ], "Content-Type: text/html; charset=euc-kr\r\n");
		iIndex += sprintf(&pBody[ iIndex ], "Content-Transfer-Encoding: 8bit\r\n\r\n");
		iIndex += sprintf(&pBody[ iIndex ], "%s\r\n\r\n", pszBody);
		iIndex += sprintf(&pBody[ iIndex ], "--%s\r\n", boundary);

		iIndex += sprintf(&pBody[ iIndex ], "Content-Type: %s; name=\"%s\"\r\n", attach_type, attach.dname);
		iIndex += sprintf(&pBody[ iIndex ], "Content-Transfer-Encoding: base64\r\n\r\n");
		iIndex += sprintf(&pBody[ iIndex ], "%s\r\n\r\n", pReplace);
		iIndex += sprintf(&pBody[ iIndex ], "--%s\r\n", boundary);

		iIndex += sprintf(&pBody[ iIndex ], "\r\n");
		
		free(pReplace);
	}
	else
	{
		sprintf(pszHeader, "%sMIME-Version: 1.0\r\n", pszHeader);
		sprintf(pszHeader, "%sContent-Type: text/html; charset=euc-kr\r\n", pszHeader);
		iIndex = sprintf(&pBody[ 0 ], "%s\r\n", pszBody);
		iIndex += sprintf(&pBody[ iIndex ], "\r\n");
	}
	
	body.dsize = iIndex;
	body.dptr = pBody;
	body.dname = NULL;
	
	sendSMTP( pResult, smtp_channel, header, pszHeader, body );
	
	free(pBody);
	free(pszHeader);
}

void sendSMTP( SMTP_RESULT* pResult, SMTP_CHANNEL smtp_channel, HEADER header, char* pszHeader, DATUM body )
{
	Q_Entry*		pRCPT;
	char*			rcpt;
	struct hostent*		hp;
	struct sockaddr_in	s;
	int	iSocket;
	char	szBuffer[ 1024 ];
	int	iSize;
	int	iIndex;
	int	i;

	iIndex = 0;
	sprintf(pResult->pszLastError, "" );
	pResult->pDeliveredList = (char*) malloc(strlen(header.pszTo)+strlen(header.pszCc)+strlen(header.pszBcc)+256);
	pResult->pDeliveredList[ 0 ] = 0x00;
	
	hp = gethostbyname(smtp_channel.pszServer);
	if ( !hp )
	{
		sprintf(pResult->pszLastError, "%s  ã  ϴ.", smtp_channel.pszServer );
		return;
	}
	bcopy( hp->h_addr, (void*) &s.sin_addr, hp->h_length );
	s.sin_family = hp->h_addrtype;
	s.sin_port = htons(smtp_channel.iPort);

	if ( (iSocket = socket( AF_INET, SOCK_STREAM, 0 )) < 0 )
	{
		sprintf(pResult->pszLastError, "%s  Socket   ϴ.", smtp_channel.pszServer );
		return;
	}
	if ( connect( iSocket, (struct sockaddr*) &s, sizeof(s) ) )
	{
		qError( "%s:%d  Socket   ϴ.", smtp_channel.pszServer, smtp_channel.iPort );
	} 
	
	if ( (iSize = readLine( iSocket, szBuffer, 512 )) < 0 )
	{
		sprintf(pResult->pszLastError, "%s  ȯ  ϴ.", smtp_channel.pszServer );
		return;
	}
	szBuffer[ iSize ] = '\x0';
	if (strncmp(szBuffer, "220 ", 4))
	{
		sprintf(pResult->pszLastError, "%s  %s ȯ  ½ϴ.", smtp_channel.pszServer, szBuffer );
		return;
	}

/*		while (str.indexOf('-') == 3)
	{
		str = client.readLine();
		cout << str << endl;
		if (!strncmp((const char*)str, "220", 3)) throw new SocketException(&client, str);
	}
*/

	sprintf( szBuffer, "HELO %s\r\n", smtp_channel.pszDomain );
	iSize = strlen(szBuffer);
	write( iSocket, szBuffer, iSize );

	if ( (iSize = readLine( iSocket, szBuffer, 512 )) < 0 )
	{
		sprintf(pResult->pszLastError, "%s  SMTP  ϴ.", smtp_channel.pszServer );
		return;
	}
	szBuffer[ iSize ] = '\x0';
	if (strncmp(szBuffer, "250 ", 4))
	{
		sprintf(pResult->pszLastError, "%s  %s SMTP  Խϴ.", smtp_channel.pszServer, szBuffer );
		return;
	}

	// On est connecte au serveur de Mail...    
	// Envoie du Mail
	sprintf( szBuffer, "MAIL FROM: %s\r\n", header.pszFrom );
	iSize = strlen(szBuffer);
	write( iSocket, szBuffer, iSize );

	if ( (iSize = readLine( iSocket, szBuffer, 512 )) < 0 )
	{
		sprintf(pResult->pszLastError, "%s  MAIL FROM: %s    ϴ.", smtp_channel.pszServer, header.pszFrom );
		return;
	}
	szBuffer[ iSize ] = '\x0';
	if (strncmp(szBuffer, "250 ", 4))
	{
		sprintf(pResult->pszLastError, "%s  MAIL FROM: %s   %s  Խϴ.", smtp_channel.pszServer, header.pszFrom, szBuffer );
		return;
	}

	// A qui envoie t on cela 
	pRCPT = qsList(header.pszTo, ',');
	i = 0;
	while( (rcpt = qsValue(pRCPT, "%d", i)) != NULL )
	{
		sprintf( szBuffer, "RCPT TO: %s\r\n", rcpt );
		iSize = strlen(szBuffer);
		write( iSocket, szBuffer, iSize );
	
		if ( (iSize = readLine( iSocket, szBuffer, 512 )) < 0 )
		{
			sprintf(pResult->pszLastError, "%s  RCPT TO: %s    ϴ.", smtp_channel.pszServer, rcpt );
			pResult->pDeliveredList[ 0 ] = 0x00;
			return;
		}
		szBuffer[ iSize ] = '\x0';
		if (strncmp(szBuffer, "250 ", 4))
		{
			sprintf(pResult->pszLastError, "%s  RCPT TO: %s   %s  Խϴ.", smtp_channel.pszServer, rcpt, szBuffer );
			pResult->pDeliveredList[ 0 ] = 0x00;
			return;
		}
		
		iIndex += sprintf(&pResult->pDeliveredList[iIndex], "%s, ", rcpt);
		i++;
	}
	qsFree(pRCPT);

	pRCPT = qsList(header.pszCc, ',');
	i = 0;
	while( (rcpt = qsValue(pRCPT, "%d", i)) != NULL )
	{
		sprintf( szBuffer, "RCPT TO: %s\r\n", rcpt );
		iSize = strlen(szBuffer);
		write( iSocket, szBuffer, iSize );
	
		if ( (iSize = readLine( iSocket, szBuffer, 512 )) < 0 )
		{
			sprintf(pResult->pszLastError, "%s  RCPT TO: %s    ϴ.", smtp_channel.pszServer, rcpt );
			pResult->pDeliveredList[ 0 ] = 0x00;
			return;
		}
		szBuffer[ iSize ] = '\x0';
		if (strncmp(szBuffer, "250 ", 4))
		{
			sprintf(pResult->pszLastError, "%s  RCPT TO: %s   %s  Խϴ.", smtp_channel.pszServer, rcpt, szBuffer );
			pResult->pDeliveredList[ 0 ] = 0x00;
			return;
		}
		
		iIndex += sprintf(&pResult->pDeliveredList[iIndex], "%s, ", rcpt);
		i++;
	}
	qsFree(pRCPT);

	pRCPT = qsList(header.pszBcc, ',');
	i = 0;
	while( (rcpt = qsValue(pRCPT, "%d", i)) != NULL )
	{
		sprintf( szBuffer, "RCPT TO: %s\r\n", rcpt );
		iSize = strlen(szBuffer);
		write( iSocket, szBuffer, iSize );
	
		if ( (iSize = readLine( iSocket, szBuffer, 512 )) < 0 )
		{
			sprintf(pResult->pszLastError, "%s  RCPT TO: %s    ϴ.", smtp_channel.pszServer, rcpt );
			pResult->pDeliveredList[ 0 ] = 0x00;
			return;
		}
		szBuffer[ iSize ] = '\x0';
		if (strncmp(szBuffer, "250 ", 4))
		{
			sprintf(pResult->pszLastError, "%s  RCPT TO: %s   %s  Խϴ.", smtp_channel.pszServer, rcpt, szBuffer );
			pResult->pDeliveredList[ 0 ] = 0x00;
			return;
		}
		
		iIndex += sprintf(&pResult->pDeliveredList[iIndex], "%s, ", rcpt);
		i++;
	}
	qsFree(pRCPT);

	// Est on pret a envoyer les donnees  
	sprintf( szBuffer, "DATA\r\n" );
	iSize = strlen(szBuffer);
	write( iSocket, szBuffer, iSize );

	if ( (iSize = readLine( iSocket, szBuffer, 512 )) < 0 )
	{
		sprintf(pResult->pszLastError, "%s  DATA   ϴ.", smtp_channel.pszServer );
		pResult->pDeliveredList[ 0 ] = 0x00;
		return;
	}
	szBuffer[ iSize ] = '\x0';
	if (strncmp(szBuffer, "354 ", 4))
	{
		sprintf(pResult->pszLastError, "%s  DATA  %s  Խϴ.", smtp_channel.pszServer, szBuffer );
		pResult->pDeliveredList[ 0 ] = 0x00;
		return;
	}

	// Emmeteur - Destinataire - Sujet
//	sprintf( szBuffer, "TO: %s <%s>\r\n", header.pszToName, header.pszTo );
//	iSize = strlen(szBuffer);
//	write( iSocket, szBuffer, iSize );
	
//	sprintf( szBuffer, "CC: %s\r\n", header.pszCc );
//	iSize = strlen(szBuffer);
//	write( iSocket, szBuffer, iSize );

//	sprintf( szBuffer, "BCC: %s\r\n", header.pszBcc );
//	iSize = strlen(szBuffer);
//	write( iSocket, szBuffer, iSize );

	sprintf( szBuffer, "SUBJECT: %s\r\n", header.pszSubject );
	iSize = strlen(szBuffer);
	write( iSocket, szBuffer, iSize );
	
	sprintf( szBuffer, "%s\r\n", pszHeader );
	iSize = strlen(szBuffer);
	write( iSocket, szBuffer, iSize );

	write( iSocket, body.dptr, body.dsize );

	sprintf( szBuffer, "\r\n.\r\n" );
	iSize = strlen(szBuffer);
	write( iSocket, szBuffer, iSize );

	if ( (iSize = readLine( iSocket, szBuffer, 512 )) < 0 )
	{
		sprintf(pResult->pszLastError, "%s  DATA ۳   ϴ.", smtp_channel.pszServer );
		pResult->pDeliveredList[ 0 ] = 0x00;
		return;
	}
	szBuffer[ iSize ] = '\x0';
	if (strncmp(szBuffer, "250 ", 4))
	{
		sprintf(pResult->pszLastError, "%s  DATA ۳  %s  Խϴ.", smtp_channel.pszServer, szBuffer );
		pResult->pDeliveredList[ 0 ] = 0x00;
		return;
	}
	
	sprintf( szBuffer, "QUIT\r\n" );
	iSize = strlen(szBuffer);
	write( iSocket, szBuffer, iSize );

	if ( (iSize = readLine( iSocket, szBuffer, 512 )) < 0 )
	{
		sprintf(pResult->pszLastError, "%s  QUIT   ϴ.", smtp_channel.pszServer );
		pResult->pDeliveredList[ 0 ] = 0x00;
		return;
	}
	szBuffer[ iSize ] = '\x0';
	if (strncmp(szBuffer, "221 ", 4))
	{
		sprintf(pResult->pszLastError, "%s  QUIT  %s  Խϴ.", smtp_channel.pszServer, szBuffer );
		pResult->pDeliveredList[ 0 ] = 0x00;
		return;
	}
	
	close( iSocket );
}

int checkQueue(int fd)
{
	fd_set set;
	struct timeval tv;
	int ret=0;
	
	tv.tv_sec=2;
	tv.tv_usec=0;
	FD_ZERO(&set);
	FD_SET(fd,&set);
	ret=select(fd+1,&set,NULL,NULL,&tv);
	
	return ret;
}

int readLine(int fd, char* ptr, int maxlen)
{
	int	i;
	int	iSize;
	int	iCount;
	char	c;
	
	i = 0;
	iCount = 0;
	c = 0;
	
	do
	{
		if ( checkQueue(fd) )
		{
			if ( (iSize = read(fd, &c, 1)) == 1)
			{
				*ptr++ = c;
			}
			else if (iSize == 0)
			{
				break;	/* EOF, some data was read */
			}
			else
			{
				i = -1;	/* error */
				break;
			}
			
			iCount = 0;
			i++;
		}
		else
		{
			iCount++;
			if ( iCount > 20 )
			{
				break;
			}
		}
	} while( (c != '\n') && (i < maxlen) );
	
	*ptr = 0;
	
	return	i;
}

/**********************************************
** Usage : qsList(string);
** Return: Success pointer of the first entry, Fail NULL.
** Do    : Save string into linked list.
           # is used for comments.
**********************************************/
Q_Entry *qsList(char *str, char delimiter) {
  Q_Entry *first, *entries, *back;
  char  *org, *buf, *offset;
  int  eos;
  int  iIndex;
  char szName[256];

  if(str == NULL) return NULL;

  first = entries = back = NULL;

  if((org = strdup(str)) == NULL) qError("qsDecoder(): Memory allocation fail.");

  iIndex = 0;
  for(buf = offset = org, eos = 0; eos == 0; ) {
    for(buf = offset; *offset != delimiter && *offset != '\0'; offset++);
    if(*offset == '\0') eos = 1;
    else *offset = '\0', offset++;

    qRemoveSpace(buf);
    if((buf[0] == '#') || (buf[0] == '\0')) continue;

    back = entries;
    entries = (Q_Entry *)malloc(sizeof(Q_Entry));
    if(back != NULL) back->next = entries;
    if(first == NULL) first = entries;

    sprintf(szName, "%d", iIndex++);
    entries->value = strdup(buf);
    entries->name  = strdup(szName);
    entries->next  = NULL;

    qRemoveSpace(entries->name);
    qRemoveSpace(entries->value);
  }

  free(org);

  return first;
}

static char base64_table[] =
	{ 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M',
	  'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z',
	  'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm',
	  'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z',
	  '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '+', '/', '\0'
	};
static char base64_pad = '=';

unsigned char *base64_encode(const unsigned char *str, int length, int *ret_length)
{
	const unsigned char *current = str;
	int i = 0;
	unsigned char *result = (unsigned char *) malloc(((length + 3 - length % 3) * 4 / 3 + 1) * sizeof(char));

	while (length > 2) { /* keep going until we have less than 24 bits */
		result[i++] = base64_table[current[0] >> 2];
		result[i++] = base64_table[((current[0] & 0x03) << 4) + (current[1] >> 4)];
		result[i++] = base64_table[((current[1] & 0x0f) << 2) + (current[2] >> 6)];
		result[i++] = base64_table[current[2] & 0x3f];

		current += 3;
		length -= 3; /* we just handle 3 octets of data */
	}

	/* now deal with the tail end of things */
	if (length != 0) {
		result[i++] = base64_table[current[0] >> 2];
		if (length > 1) {
			result[i++] = base64_table[((current[0] & 0x03) << 4) + (current[1] >> 4)];
			result[i++] = base64_table[(current[1] & 0x0f) << 2];
			result[i++] = base64_pad;
		}
		else {
			result[i++] = base64_table[(current[0] & 0x03) << 4];
			result[i++] = base64_pad;
			result[i++] = base64_pad;
		}
	}
	if(ret_length) {
		*ret_length = i;
	}
	result[i] = '\0';
	return result;
}
