typedef struct
{
	char	pszLastError[ 1024 ];
	char*	pDeliveredList;
} SMTP_RESULT;

typedef struct
{
	char*	pszServer;
	int	iPort;
	char*	pszDomain;
} SMTP_CHANNEL;

typedef struct
{
	char*	pszFromName;
	char*	pszFrom;
	char*	pszToName;
	char*	pszTo;
	char*	pszCc;
	char*	pszBcc;
	char*	pszXMailer;

	char*	pszSubject;
} HEADER;

typedef struct
{
	int   dsize;
	char*	dname;
	char*	dptr;
} DATUM;

typedef struct
{
	int			iCode;
	char const	*pszInfo;
	char const	*pszMsg;
} SMTPInfo;

Q_Entry*	qsList(char *str, char delimiter);
void qSendmail( SMTP_RESULT* pResult, SMTP_CHANNEL smtp_channel, HEADER header, char* pszBody, DATUM attach );
